/********************************************************************
  Mega Mario SRC
    created:	2005/09/18
	created:	18:9:2005   10:13
	author:		Jens Wellmann (c)
*********************************************************************/



#include "Global.h"

SDL_Surface *screen;
SDL_Surface *helpscreen;

SDL_Event event;

Uint8 *keys;

char* cheatcode;

bool Real_Fullscreen;

 int WIDTH = 640,GL_Width=1024;
 int HEIGHT = 480,GL_Height=768;

double frame_multi;

bool NoFrameCheck = 0,gameStarted = 0,gameStartedVirtual = 0,pixelation=1,show_blood = 0,cheater=0;
int nosound = 1;

Uint32 magenta;
int cam_x=50,cam_y=3200,bonus_activ=0;

Mix_Chunk *SOUND[MAX_SOUNDS];
Mix_Music *MUSIC,*STARSOUND;
int musicvolume=0,soundvolume;

TTF_Font* font;

int flags;

int GOOMBAcount;
cGoomba* GOOMBA[MAXENEMY];
int GOOMBABIGcount;
cGoombaBig *GOOMBABIG[5];
int TURTLEcount;
cTurtle *TURTLE[MAXENEMY];
int TURTLEFLYcount;
cTurtleFly *TURTLEFLY[MAXENEMY];
int SPINYcount;
cSpiny *SPINY[MAXENEMY];
int FIRECIRCLEcount;
cFireCircle *FIRECIRCLE[MAXENEMY];
int CANNONcount;
cCannon *CANNON[MAXENEMY];
int KILLERBLUMEcount;
cKillerBlume *KILLERBLUME[MAXENEMY];
int BRETTcount;
cBrett *BRETT[MAXENEMY];

cBowser* BOWSER = 0;

cScene *LEVEL;
cPlayer *PLAYER;
cBonus* BONUS_DYNAMIC[5];
cGlidder *GLIDDER;
cCrack *CRACK;
cFireball *FIREBALL[2];
cScore* SCORE;
cFire* FIRE;
cBlood *BLOOD_GENERATOR;

cGamepad *Gamepad;
HUD_STRUCT HUD;

void loadGlobalSprites()
{
	SOUND[S_GROW] = Mix_LoadWAV ("data/sfx/grow.wav");
	SOUND[S_JUMP] = Mix_LoadWAV ("data/sfx/jump.wav");
	SOUND[S_CRACK] = Mix_LoadWAV ("data/sfx/crack.wav");
	SOUND[S_COIN] = Mix_LoadWAV ("data/sfx/coin.wav");
	SOUND[S_KICK] = Mix_LoadWAV ("data/sfx/kick.wav");
	SOUND[S_STOMP] = Mix_LoadWAV ("data/sfx/stomp.wav");
	SOUND[S_FIREBALL] = Mix_LoadWAV ("data/sfx/fireball.wav");
	SOUND[S_STAGE_CLEAR] = Mix_LoadWAV ("data/sfx/stage_clear.wav");
	SOUND[S_1UP] = Mix_LoadWAV ("data/sfx/1-up.wav");
	SOUND[S_DIE] = Mix_LoadWAV ("data/sfx/die.wav");
	SOUND[S_GAMEOVER] = Mix_LoadWAV ("data/sfx/gameover.wav");
	SOUND[S_PAUSE] = Mix_LoadWAV ("data/sfx/pause.wav");
	SOUND[S_PIPE] = Mix_LoadWAV ("data/sfx/pipe.wav");
	SOUND[S_FLAG] = Mix_LoadWAV ("data/sfx/flag.wav");
	SOUND[S_BOWSERFALL] = Mix_LoadWAV ("data/sfx/bowserfall.wav");
	SOUND[S_SHRINK] = Mix_LoadWAV ("data/sfx/shrink.wav");
	SOUND[S_OUTPUT] = Mix_LoadWAV ("data/sfx/output.wav");
	SOUND[S_TOCK] = Mix_LoadWAV ("data/sfx/tock.wav");
	SOUND[S_STOMP2] = Mix_LoadWAV ("data/sfx/stomp_1.wav");
	SOUND[S_CANNON] = Mix_LoadWAV ("data/sfx/cannon.wav");


	LEVEL->Bonus_Textures[1] = LoadIMG("data/gfx/bonus/crackstone.png");
	LEVEL->Bonus_Textures[2] = LoadIMG("data/gfx/bonus/box.png");
	LEVEL->Bonus_Textures[3] = LoadIMG("data/gfx/bonus/box.png");
	LEVEL->Bonus_Textures[4] = LoadIMG("data/gfx/bonus/box.png");
	LEVEL->Bonus_Textures[5] = LoadIMG("data/gfx/bonus/stern.png");
	LEVEL->Bonus_Textures[6] = LoadIMG("data/gfx/bonus/pilz.png");
	LEVEL->Bonus_Textures[7] = LoadIMG("data/gfx/bonus/boxempty.png");
	LEVEL->Bonus_Textures[8] = LoadIMG("data/gfx/bonus/invis.png");
	LEVEL->Bonus_Textures[9] = LoadIMG("data/gfx/bonus/life.png");
	LEVEL->Bonus_Textures[10] = LoadIMG("data/gfx/bonus/COIN1.png");
	LEVEL->Bonus_Textures[11] = LoadIMG("data/gfx/bonus/COIN2.png");
	LEVEL->Bonus_Textures[12] = LoadIMG("data/gfx/bonus/COIN3.png");
	LEVEL->Bonus_Textures[13] = LoadIMG("data/gfx/bonus/COIN4.png");
	LEVEL->Bonus_Textures[14] = LoadIMG("data/gfx/bonus/crackstone2.png");
	LEVEL->Bonus_Textures[15] = LoadIMG("data/gfx/bonus/invis.png");
	LEVEL->Bonus_Textures[16] = LoadIMG("data/gfx/bonus/box.png");
	LEVEL->Bonus_Textures[17] = LoadIMG("data/gfx/bonus/axe.png");
	LEVEL->Bonus_Textures[18] = LoadIMG("data/gfx/bonus/fire1.png");
	LEVEL->Bonus_Textures[19] = LoadIMG("data/gfx/bonus/fire2.png");
	LEVEL->Bonus_Textures[20] = LoadIMG("data/gfx/bonus/crackedlong.png");

	helpscreen = LoadIMG("data/gfx/story/help.png");

	initGOOMBA();
	initSPINY();
	initTURTLE();
	initCANNON();
	initKILLERBLUUME();
	initBRETT();
	initGOOMBAbig();
	STARSOUND = Mix_LoadMUS("data/sfx/star.mid");

}
void unloadGlobalSprites()
{
	for(int i=1;i<MAX_BONUS_TEXTURES;i++)
		SDL_FreeSurface(LEVEL->Bonus_Textures[i]);
	
	SDL_FreeSurface(screen);
}

void THEGAMEENDSHERE()
{


	char * as=new char[2000];
	strcpy(as,"data/levels/old/lab/main\n!- The extreme MarioTestLab - Massacre -!\ndata/levels/menulevel2\n!- The funky death Jump -!\ndata/levels/old/2/main\n!- The first level of the original SMB -!\ndata/levels/old/1/main\n#- Nonsense -#\ndata/levels/1/main\nLev. 1 - The Escape from the castle\ndata/levels/2/main\nLev. 2 - Getaway\ndata/levels/3/main\nLev. 3 - The story starts\ndata/levels/4/main\nLev. 4 - Gettin' higher\ndata/levels/5/main\nLev. 5 - First castle\ndata/levels/6/main\nLev. 6 - Crossed pipes\ndata/levels/7/main\nLev. 7 - What about stars ?\ndata/levels/8/main\nLev. 8 - Bullet Bill strikes back\ndata/levels/9/main\nLev. 9 - Castle 2 - Deep down below\ndata/levels/10/main\nLev. 10 - The Egypt hole 1\ndata/levels/11/main\nLev. 11 - The Hole 2\ndata/levels/12/main\nLev. 12 - Nice weather\ndata/levels/13/main\nLev. 13 - Castle 3 - Trapped\ndata/levels/14/main\nLev. 14 - A lovely canyon\ndata/levels/15/main\nLev. 15 - Fire in the Hole\ndata/levels/16/main\nLev. 16 - Maze\ndata/levels/17/main\n");
	strcat(as,"Lev. 17 - Canyon Bowser Battle\ndata/levels/18/main\nLev. 18 - ?????????????????\ndata/levels/19/main\nLev. 19 - Castle 4 - Climb The Evil\ndata/levels/20/main\nLev. 20 - Elevator Attator\ndata/levels/21/main\nLev. 21 - Big World\ndata/levels/22/main\nLev. 22 - Bullet Bill\ndata/levels/23/main\nLev. 23 - Way to hell\ndata/levels/24/main\nLev. 24 - Final Castle - Power Battle");
	ofstream ofs( "data/levels/levellist.txt");
	for(int i=0;i<strlen(as);i++)
		ofs<<as[i];

	
	
	playMusic("ending.mid");
	SDL_Surface * surfs;	

	surfs = LoadIMG("data/gfx/story/outro1");


	bool ACDC=1;
	while(ACDC)
	{
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					exitos();
					break;
				case SDL_KEYDOWN:
					ACDC = 0;
				break;
			}
		}
		SDL_UpperBlit(surfs,0,screen,0);
		
		drawGLscreen();
	}
	SDL_FillRect(screen,0,0);
	drawGLscreen();
	SDL_FreeSurface(surfs);
	surfs = LoadIMG("data/gfx/story/outro2");
	SDL_Delay(500);
ACDC=1;
	while(ACDC)
	{
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					exitos();
					break;
				case SDL_KEYDOWN:
					ACDC = 0;
				break;
			}
		}
		SDL_UpperBlit(surfs,0,screen,0);
		drawGLscreen();
	}SDL_FillRect(screen,0,0);
	drawGLscreen();
	SDL_FreeSurface(surfs);
	surfs = LoadIMG("data/gfx/story/outro3");
	SDL_Delay(500);
	ACDC=1;
	while(ACDC)
	{
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					exitos();
					break;
				case SDL_KEYDOWN:
					ACDC = 0;
				break;
			}
		}
		SDL_UpperBlit(surfs,0,screen,0);
		drawGLscreen();
	}SDL_FillRect(screen,0,0);
	drawGLscreen();
	SDL_FreeSurface(surfs);
	surfs = LoadIMG("data/gfx/story/outro4");
	SDL_Delay(500);
	ACDC=1;
	while(ACDC)
	{
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					exitos();
					break;
				case SDL_KEYDOWN:
					ACDC = 0;
				break;
			}
		}
		SDL_UpperBlit(surfs,0,screen,0);
		drawGLscreen();
	}SDL_FillRect(screen,0,0);
	drawGLscreen();
	SDL_FreeSurface(surfs);
	surfs = LoadIMG("data/gfx/story/outro5");
	SDL_Delay(500);
	ACDC=1;
	while(ACDC)
	{
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					exitos();
					break;
				case SDL_KEYDOWN:
					ACDC = 0;
				break;
			}
		}
		SDL_UpperBlit(surfs,0,screen,0);
		drawGLscreen();
	}SDL_FillRect(screen,0,0);
	drawGLscreen();
	SDL_FreeSurface(surfs);
	surfs = LoadIMG("data/gfx/story/outro6");
	SDL_Delay(500);
ACDC=1;
	while(ACDC)
	{
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					exitos();
					break;
				case SDL_KEYDOWN:
					ACDC = 0;
				break;
			}
		}
		SDL_UpperBlit(surfs,0,screen,0);
		drawGLscreen();
	}
	SDL_FreeSurface(surfs);
	
	
	loadlevellist();
	showMenu();
}




void instruct()
{
	bool READY=0;

	SDL_Surface* sch = LoadIMG("data/gfx/menu/insctructions.jpg");
	
	SDL_UpperBlit(sch,0,screen,0);
	drawGLscreen();
	SDL_BlitSurface(sch,0,screen,0);
	drawGLscreen();
	
	SDL_Delay(2000);
	SDL_Event MegaEvent;
	while(!READY)
	{
		while(SDL_PollEvent(&MegaEvent))
		{
			switch(MegaEvent.type)
			{
					case SDL_KEYDOWN:
					READY=1;
				break;
								
			}			
		}
	}
	SDL_FreeSurface(sch);
}