/********************************************************************
	created:	2005/09/18
	created:	18:9:2005   10:13
	filename: 	main.cpp
	author:		Jens Wellmann (c)
*********************************************************************/


#include "Global.h"
#include <time.h>




bool running;

LARGE_INTEGER tickspersecond;
LARGE_INTEGER currentticks;
LARGE_INTEGER framedelay;
int fps,framecount = 5,targetfps=60;


char* FRAMECHAR = new char[1];

#define C_BLACK			0
#define C_DARKBLUE		1
#define C_DARKGREEN		2
#define C_DARKBEIGE		3
#define C_DARKRED		4
#define C_DARKPURPLE	5
#define C_DARKYELLOW	6
#define C_GREY			7
#define C_DARKGREY		8
#define C_BLUE			9
#define C_GREEN			10
#define C_BEIGE			11
#define C_RED			12
#define C_PURPLE		13
#define C_YELLOW		14
#define C_WHITE			15





	char  szAppName[] = "Mario";
	static char szIniFile [MAX_PATH];

	

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )

{

	srand(time(0)); 
  
	QueryPerformanceCounter(&framedelay);
	QueryPerformanceFrequency(&tickspersecond); 

	flags = 0;

	Real_Fullscreen=0;
		// OPTIONS LOAD :
	GetModuleFileName (NULL, szIniFile, sizeof (szIniFile)) ;
    strcpy (strrchr (szIniFile, '.') + 1, "ini") ;

    pixelation = GetPrivateProfileInt(szAppName, "Pixelation",1, szIniFile);
	show_blood = GetPrivateProfileInt(szAppName, "Blood",1, szIniFile);
	nosound = GetPrivateProfileInt(szAppName, "Sound",2, szIniFile);	
#ifdef Use_OPENGL
	WIDTH = GetPrivateProfileInt(szAppName, "SCREEN_W",640, szIniFile);	
	HEIGHT = GetPrivateProfileInt(szAppName, "SCREEN_H",480, szIniFile);
else
	WIDTH = 640;
	HEIGHT = 480;
#endif
	GL_Width = 1024; //GetPrivateProfileInt(szAppName, "SCREEN_W",640, szIniFile);
	GL_Height = 768; //GetPrivateProfileInt(szAppName, "SCREEN_H",480, szIniFile);
	if(GetPrivateProfileInt(szAppName, "FULLSCREEN",1, szIniFile))
		Real_Fullscreen = 1;
	if(GetPrivateProfileInt(szAppName, "showFPS",0, szIniFile))
		NoFrameCheck = 1;
		
	NoFrameCheck = 1;
	//GAME SPEED READ IN :
	targetfps = GetPrivateProfileInt(szAppName, "Gamespeed",70, szIniFile);
	if(targetfps<10)	
		targetfps = 10;
	if(targetfps>150)	
		targetfps = 150;

	
    initGame(); //SDL_ SCREEN INIT;
	
	
	initMenu();

	
	setGame();

	
	running = 1;
	while(running) 
	{
		gameEvent();
		framerate();
	}	

exitos();

return(0);
}


void initGame()
{

	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO) < 0) 
	{
        fprintf(stderr, "SDL konnte nicht initialisiert werden: %s\n",SDL_GetError());
	     running=0;
    }


	if (Mix_OpenAudio (44800, AUDIO_S16, 2, 4096) == -1)
	{
		printf ("Can't open audio subsystem...");
		nosound = true;
	}
	

	if (TTF_Init()==-1)
	{
		printf ("Can't open TTF Subsystem...");
	}

	SDL_InitSubSystem(SDL_INIT_JOYSTICK);



    atexit(SDL_Quit);

#ifdef Use_OPENGL
	

    SDL_SetVideoMode(GL_Width, GL_Height, SCREEN_BPP ,SDL_OPENGL|SDL_GL_DOUBLEBUFFER);
	
	//InitOpenGL();

	Uint32 rmask, gmask, bmask, amask;

	rmask = 0xff000000;
	gmask = 0x00ff0000;
	bmask = 0x0000ff00;
	amask = 0x000000ff;

	SDL_Surface *temp;

	screen = SDL_CreateRGBSurface( SDL_HWSURFACE, WIDTH, HEIGHT, SCREEN_BPP , rmask, gmask, bmask, amask );

	screen = SDL_DisplayFormat( temp );

	SDL_FreeSurface( temp );
#else
	flags |= (SDL_DOUBLEBUF|SDL_RLEACCEL|SDL_HWSURFACE|SDL_SRCALPHA|SDL_SRCCOLORKEY);
	if(Real_Fullscreen)
		flags|=SDL_FULLSCREEN;
	screen = SDL_SetVideoMode(WIDTH, HEIGHT, SCREEN_BPP ,flags);

#endif

	Gamepad = new cGamepad;
	Gamepad->init();
	SDL_ShowCursor(SDL_DISABLE);

	SDL_WM_SetCaption(CAPTION, NULL);

	magenta = SDL_MapRGB(screen->format, 255, 0, 255);

}

void setGame()
{
	LEVEL = new cScene();
	for(int i=0;i<5;i++)
		BONUS_DYNAMIC[i] = new cBonus();
	CRACK = new cCrack();
	FIREBALL[0] = new cFireball();
	FIREBALL[1] = new cFireball();
	GLIDDER = new cGlidder();
	SCORE = new cScore();
	FIRE = new cFire();
	BLOOD_GENERATOR = new cBlood();

	cheatcode = new char[10];
	
	font = TTF_OpenFont ("data/style.TTF",20);
	TTF_SetFontStyle (font, 0) ;
	
	loadGlobalSprites();
	
	showMenu();
	

}
char* HUDTEXT;
void gameEvent()
{

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_QUIT:
			exitos();
			break;
			
			case SDL_KEYDOWN:
			if(event.key.keysym.sym == SDLK_ESCAPE)
			{	showMenu();}
			if(event.key.keysym.sym == SDLK_RETURN)
				BLOOD_GENERATOR->newBlood(PLAYER->x,PLAYER->y);

			if(event.key.keysym.sym == SDLK_F12)
			{
				char gammel[100];
				sprintf(gammel,"screenshots/%d.bmp",rand()%10000);
				SDL_SaveBMP(screen,gammel);
				delete[] gammel;
			}
		
			break;	
		}	
		Gamepad->Handle_Event();
	}	



	keyInput();
	
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glLoadIdentity();
	SDL_FillRect(screen,0,LEVEL->BGCOLOR);

	PLAYER->update();
	LEVEL->drawBackground();
	int i;
	for(i=0;i<KILLERBLUMEcount;i++)
		KILLERBLUME[i]->update();
	for(i=0;i<5;i++)
		BONUS_DYNAMIC[i]->update();
	LEVEL->drawLevel();	
	
	FIRE->update();
	for(i=0;i<GOOMBAcount;i++)
		GOOMBA[i]->update();
	for(i=0;i<TURTLEcount;i++)
		TURTLE[i]->update();
	for(i=0;i<TURTLEFLYcount;i++)
		TURTLEFLY[i]->update();
	for(i=0;i<SPINYcount;i++)
		SPINY[i]->update();
	for(i=0;i<FIRECIRCLEcount;i++)
		FIRECIRCLE[i]->update();
	for(i=0;i<CANNONcount;i++)
		CANNON[i]->update();
	for(i=0;i<BRETTcount;i++)
		BRETT[i]->update();
	for(i=0;i<GOOMBABIGcount;i++)
		GOOMBABIG[i]->update();

	if(show_blood&&!PLAYER->STARPOWER)
		BLOOD_GENERATOR->update();

	if(BOWSER)
		BOWSER->update();

	CRACK->update();
	updateKickUp();
	PLAYER->draw();
	
	
	FIREBALL[0]->update();
	FIREBALL[1]->update();
	GLIDDER->update();
	SCORE->update();
	
		
	HUDTEXT = new char[70];
	sprintf(HUDTEXT,"SCORE : %d    COINS : %d    LIFES : %d",HUD.score,HUD.coins,HUD.lifes);
	StringColor(screen,50,25,HUDTEXT,14606000);
	delete[] (HUDTEXT);

	if(NoFrameCheck)
		StringColor(screen,0,0,FRAMECHAR,14605935);

	if(keys[SDLK_h]||keys[SDLK_F1])
	{
		tmp_rect.x=WIDTH/2-125;
		tmp_rect.y=HEIGHT/2-22;
		SDL_UpperBlit(helpscreen,0,screen,&tmp_rect);
	}

	//Gamepad->drawStats();
	
	
	drawGLscreen();
	//SDL_Flip(screen);

	if(PLAYER->dead)
		died();
	
	
}



void died()
{
	if(HUD.lifes<=1)
	{
		PLAYSOUND1(S_GAMEOVER);
		gameStartedVirtual = 0;
		showMenu();		
	}
	else
	{
		SDL_FillRect(screen,0,0);
		StringColor(screen,300,230,"Reviving...",-6536532);
		drawGLscreen();

		SDL_Delay(100);

	//	cout<<" ACHTUNG ::::::::::: "<<LEVEL->nowlevel<<endl<<endl<<endl;

		LEVEL->loadLevel(LEVEL->RESTARTLevel,0);
		
		HUD.lifes--;
		PLAYER->invincible = 0;
	}
	PLAYER->dead = 0;
	PLAYER->x_speed = 0;
	PLAYER->y_speed = 0;
	PLAYER->changeStat(0);
}
void framerate()
{
   		if(NoFrameCheck)
		{		
			framecount++;
			if(framecount>10)
			{
				QueryPerformanceCounter(&currentticks);
  				frame_multi = (double)(currentticks.QuadPart-framedelay.QuadPart)/((double)(tickspersecond.QuadPart*10)/65);
				framecount = 0;
				delete[] FRAMECHAR;
				FRAMECHAR = new char[10];
				fps = (int)(65/frame_multi);
				sprintf(FRAMECHAR,"%d FPS",fps);			
				if (frame_multi <= 0)
					frame_multi = 1;
				framedelay = currentticks;
			}
		}

  	static Uint32 stime = 0;	
	while(SDL_GetTicks() - stime < 1000/targetfps);
	stime = SDL_GetTicks();
}




void exitos(void)
{
	// Write the Keys :

	char szBuffer [MAX_PATH];
    wsprintf(szBuffer, "%i",pixelation);
    WritePrivateProfileString(szAppName, "Pixelation", szBuffer, szIniFile);
	wsprintf(szBuffer, "%i",show_blood);
    WritePrivateProfileString(szAppName, "Blood", szBuffer, szIniFile);
	wsprintf(szBuffer, "%i",nosound);
    WritePrivateProfileString(szAppName, "Sound", szBuffer, szIniFile);

	wsprintf(szBuffer, "%i",WIDTH);
    WritePrivateProfileString(szAppName, "SCREEN_W", szBuffer, szIniFile);
	wsprintf(szBuffer, "%i",HEIGHT);
    WritePrivateProfileString(szAppName, "SCREEN_H", szBuffer, szIniFile);

	if(flags &  SDL_FULLSCREEN)
		wsprintf(szBuffer, "%i",1);
	else
		wsprintf(szBuffer, "%i",0);
    WritePrivateProfileString(szAppName, "FULLSCREEN", szBuffer, szIniFile);
	if(NoFrameCheck)
		wsprintf(szBuffer, "%i",1);
	else
		wsprintf(szBuffer, "%i",0);
    WritePrivateProfileString(szAppName, "showFPS", szBuffer, szIniFile);

	Set_Console_Color(C_YELLOW,C_DARKGREEN);
	running = 0;
	printf("\n\nbitmaps unloaded.\n\nEXIT \n0 ERRORS\n");
	Mix_CloseAudio();
	unloadGlobalSprites();
	Gamepad->Close();
	delete Gamepad;
	delete LEVEL;
//
//	
//	
// delete GOOMBA;
// delete GOOMBABIG;
// delete TURTLE;
// delete TURTLEFLY;
// delete SPINY;
// delete FIRECIRCLE;
// delete CANNON;
// delete KILLERBLUME;
// delete BRETT;
// delete PLAYER;
// delete BONUS_DYNAMIC;
// delete CRACK;
// delete GLIDDER;
// delete SCORE;
// delete FIRE;
// delete BOWSER;
// delete FIREBALL;
// delete BLOOD_GENERATOR;

//	
	exit(1);
}





